#declare num_cyl=14
#declare cnt_cyl=1
#declare semi_caf_sup=
union{
 cone{
  <0,7.6,0>,7.2/2
  <0,7.4,0>,6.8/2
  texture{t_metal_caf}
 }
 difference{
  cone{
   <0,12.8,0>,8.6/2
   <0,7.6,0>,7.2/2
  }
  #while (cnt_cyl<=num_cyl)
   cylinder{
    <0,12.9,0>
    <0,7.5,0>
    1
    scale <1,1,0.2>
    rotate -10*x
    translate -(4.5/2)*z
    rotate (360*(cnt_cyl/num_cyl))*y
   }
   #declare cnt_cyl=cnt_cyl+1
  #end
  bounded_by{
   cone{
    <0,12.8,0>,8.6/2
    <0,7.6,0>,7.2/2
   }
  }
  texture{t_metal_caf}
 }
 cylinder{
  <0,6,0>
  <0,7.4,0>
  6.8/2
  texture{t_metal_caf rotate 90*z}
 }
}
#declare num_cyl=14
#declare cnt_cyl=1
#declare semi_caf_inf=
union{
 cone{
  <0,5.4,0>,6.8/2
  <0,5.8,0>,6.6/2
  texture{t_metal_caf}
 }
 difference{
  cone{
   <0,0.2,0>,8.2/2
   <0,5.4,0>,6.8/2
  }
  #while (cnt_cyl<=num_cyl)
   cylinder{
    <0,5.3,0>
    <0,0.1,0>
    0.9
    scale <1,1,0.2>
    rotate 5*x
    translate -(8.2/2)*z
    rotate (360*(cnt_cyl/num_cyl))*y
   }
   #declare cnt_cyl=cnt_cyl+1
  #end
  bounded_by{
   cone{
    <0,0.2,0>,8.2/2
    <0,5.4,0>,6.8/2
   }
  }
  texture{t_metal_caf}
 }
 cylinder{
  <0,7,0>
  <0,5.8,0>
  6.6/2
  texture{t_metal_caf rotate 90*z}
 }
 cylinder{
  <0,0,0>
  <0,0.2,0>
  8/2
  texture{t_metal_caf rotate 90*z}
 }
}
#declare num_cyl=14
#declare cnt_cyl=1
#declare tapa=
difference{
 cylinder{
  <0,0,0>
  <0,0.6,0>
  8.7/2
 }
 #while (cnt_cyl<=num_cyl)
  cylinder{
   <0,1,0>
   <0,-1,0>
   1
   scale <1,1,0.2>
   translate -(8.6/2)*z
   rotate (360*(cnt_cyl/num_cyl))*y
  }
  cone{
   <0,0,0>,0.4
   <0,0,-8.8/2>,2
   scale <1,0.1,1>
   rotate -8*x
   translate 1.05*y
   rotate (360*(cnt_cyl/num_cyl))*y
  }
  #declare cnt_cyl=cnt_cyl+1
 #end
 bounded_by{
  cylinder{
   <0,0,0>
   <0,0.6,0>
   8.7/2
  }
 }
 texture{t_metal_caf rotate -90*x}
}
#declare protector=
superellipsoid{
 <1,.1>
 rotate 90*x
 scale <6,1,6>
 texture{t_soporte}
}
#declare pomo=
lathe{
 linear_spline
 7
 <0,0>
 <0,0>
 <1.5/2,0>
 <1.8/2,1.8>
 <0.5/2,2>
 <0,2>
 <0,2>
 texture{t_plast_negro}
}
#declare pico=
difference{
 intersection{
  cone{
   <0,4,0>,2
   <0,0,0>,0
  }
  plane{
   x,0
   rotate 12*y
   rotate -12*z
  }
  plane{
   x,0
   inverse
   rotate -12*y
   rotate 12*z
   }
 }
 intersection{
  cone{
   <0,5,0>,1.8
   <0,0,0>,0
  }
  plane{
   x,0
   rotate 8*y
   rotate -8*z
  }
  plane{
   x,0
   inverse
   rotate -8*y
   rotate 8*z
  }
 }
 texture{t_metal_caf}
}
#declare cafetera=
union{
 object{protector translate 1*y}
 union{
  object{pico
   translate <0,9,-4>
  }
  object{pomo
   translate 13*y
  }
  object{tapa
   translate 12.82*y
  }
  object{semi_caf_sup rotate (360/28)*y}
  object{semi_caf_inf}
  translate 2*y
 }
 #if (trazar_humos=1)
 difference{
  sphere{
   <0,0,0>,1
   hollow
   texture{
    pigment { color rgbt <1,1,1,1>}
     halo {
      emitting
      spherical_mapping
      linear
      turbulence 1.7
      color_map {
       [ 0.0 White transmit  1]
       [ 0.4 Gray  transmit 0.5]
       [ 1.0 White filter 0.5 transmit 1]
      }
      frequency 2
      samples 20
      scale 0.5
     }
   }
  }
  box{<-1,-1,-1>,<1,0,1>}
  scale <0.6,6,0.6>
  translate <0,14,-4.8>
 }
 #end
}

